> For the complete documentation index, see [llms.txt](https://docs.geopard.tech/geopard-tutorials/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.geopard.tech/geopard-tutorials/ru/dokumentaciya-api/geopard-api-requests-overview/56.-upload-photos.md).

# 56. Загрузка фотографий

Загрузка фотографии через S3 состоит из 2 шагов:

1. **Запросите предварительно подписанную ссылку для прямой загрузки.**

В качестве входных данных:

* fileExtention — jpeg ИЛИ jpg ИЛИ png,
* farmUuid — UUID хозяйства,
* fieldUuid — UUID поля,
* noteUuid — UUID заметки, для которой предназначена прямая ссылка на загруженную фотографию,
* commentUuid — UUID комментария, для которого предназначена прямая ссылка на загруженную фотографию (необязательно).

В качестве выходных данных:

* uuid — ожидаемый UUID после загрузки и обработки,
* farmUuid — такой же, как во входных данных,
* fieldUuid — такой же, как во входных данных,
* noteUuid — такой же, как во входных данных,
* commentUuid — такой же, как во входных данных (если указан),
* s3Url — URL для загрузки фотографии,
* s3Fields — атрибуты, которые нужно передать в форму загрузки фотографии.

Подробное описание использования s3Url и s3Fields приведено во втором шаге.

Атрибуты действительны для загрузки фотографии только в течение 60 минут.

{% code overflow="wrap" lineNumbers="true" %}

```graphql
mutation generatePresignedPostPhotoData {
  generatePresignedPostPhotoData(input:{
    farmUuid: "89196056-61e5-4bce-b676-d488d611a829" 
    fieldUuid: "586a2ef2-03e4-4715-846c-07a2f0cb3016"
    noteUuid: "4a94da1c-f655-4f17-961a-4b0323e5129c"
    fileExtention: jpeg
    
  } ) {
    uuid
    noteUuid
    fieldUuid
    farmUuid
    s3Url
    s3Fields
  }
}
```

{% endcode %}

2. **Отправьте фотографию с устройства на s3Url, используя заданные атрибуты формы из s3Fields.**

{% code overflow="wrap" lineNumbers="true" %}

```bash
curl --location --request POST '<s3Url>' \
--form 'key="<value_in_s3Fields>"' \
--form 'AWSAccessKeyId="<value_in_s3Fields>"' \
--form 'x-amz-security-token="<value_in_s3Fields>"' \
--form 'policy="<value_in_s3Fields>"' \
--form 'signature="<value_in_s3Fields>"' \
--form 'file=@"<local_file_path>"'
```

{% endcode %}

Уведомления об обработке будут доставляться через механизм подписки, описанный в разделе GraphQL -> Примеры -> [1. Подписка: получение событий](https://docs.geopard.tech/geopard-tutorials/ru/dokumentaciya-api/geopard-api-requests-overview/1.-subscription-get-events.md).

{% hint style="info" %}
Используйте ‘Accept-Encoding’:’gzip, deflate, br’.&#x20;
{% endhint %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.geopard.tech/geopard-tutorials/ru/dokumentaciya-api/geopard-api-requests-overview/56.-upload-photos.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
